(* Program: LogOn               *)
(* Author:  Leon McClatchey     *)
(* Date:    3/21/91             *)
MODULE LogOn;

FROM InOut      IMPORT  Read, ReadString, Write, WriteString, WriteLn, Done;
FROM InOut      IMPORT  RedirectOutput, CloseOutput, WriteCard, WriteInt;
FROM InOut      IMPORT  OpenInput;
FROM FileSystem IMPORT  Lookup, Close, File, WriteChar, WriteWord;
FROM FileSystem IMPORT  ReadChar, ReadWord, Reset;
FROM Strings    IMPORT  Delete, CompareStr, Assign;
FROM Terminal   IMPORT  ClrScreen;

TYPE    String14 =  ARRAY [0..13] OF CHAR;
        String10 =  ARRAY [0..9] OF CHAR;
        String8  =  ARRAY [0..7] OF CHAR;
        String6  =  ARRAY [0..5] OF CHAR;
        LogFile  =  ARRAY [0..15] OF CHAR;
                    User =  RECORD
                        Name:   String10;
                        Secret: String6;
                    END;
VAR     UserId:     String10;
        TestId:     String10;
        PassWord:   String6;
        TestPw:     String6;
        OldWord:    String6;
        SavePw:     String6;
        ch:         CHAR;
        pc:         CHAR;
        C, AP, TP:  INTEGER;
        SaveAP:     INTEGER;
        Position:   INTEGER;
        Found:      BOOLEAN;
        NewLog:     BOOLEAN;
        SignOn:     File;
        UserLog:    ARRAY [0..20] OF User;

PROCEDURE TestUser;
BEGIN;
    AP := 0;
    LOOP
        IF AP > 20 THEN
            Found := FALSE;
            NewLog := FALSE;
            RETURN;
        END;
        IF CompareStr(UserLog[AP].Name, UserId) = 0 THEN
            Found := TRUE;
            RETURN;
        END;
        IF (UserLog[AP].Name[1] < 101C) OR (UserLog[AP].Name[1] > 132C) THEN
                NewLog := TRUE;
                Found := FALSE;
                RETURN;
        END;
        IF (UserLog[AP].Name[1] > 100C) AND (UserLog[AP].Name[1] < 133C) THEN
                NewLog := FALSE;
                INC(AP);
        END;
        IF (NewLog = TRUE) OR (Found = TRUE) THEN RETURN END;
    END;
END TestUser;

PROCEDURE MakeUser;
BEGIN;
    ClrScreen;
    WriteString("We could not find your name in the LogFile!");
    WriteLn;
    WriteLn;
    WriteString("Do you wish to add your name to this Log (Y/N)?");
    Read(ch);
    IF CAP(ch) = "N" THEN
        WriteLn;
        WriteLn;
        WriteString("OKAY, So we won't add your name to the Log!");
        WriteLn;
        RETURN;
    END;
    IF AP > 0 THEN
        ClrScreen;
        WriteString("Please have the System Administrator enter his or her ");
        WriteLn;
        WriteString("Authorization ID and Password.");
        WriteLn;
        Assign(UserId, TestId);
        Assign(PassWord, TestPw);
        SaveAP := AP;
        LOOP
            GetUser;
            GetWord;
            TestUser;
            IF (Found = TRUE) AND (AP = 0) THEN EXIT END;
        END;
        Assign(TestId, UserId);
        Assign(TestPw, PassWord);
        AP := SaveAP;
    END;
    LOOP
        IF AP > 20 THEN
            Found := FALSE;
            EXIT;
        END;
        IF (UserLog[AP].Name[0] < 101C) OR (UserLog[AP].Name[0] > 132C) THEN
            FOR C := 0 TO 9 DO
                UserLog[AP].Name[C] := UserId[C];
            END;
            FOR C:= 0 TO 5 DO
                UserLog[AP].Secret[C] := PassWord[C];
            END;
            NewLog := FALSE;
            Found := TRUE;
            EXIT;
        END;
        IF (UserLog[AP].Name[0] > 100C) AND (UserLog[AP].Name[0] < 133C) THEN
            INC(AP);
        END;
    END;
END MakeUser;

PROCEDURE GetLog;
BEGIN;
    Lookup(SignOn,"Logon.log",TRUE);
    Reset(SignOn);
    AP := 0;
    LOOP
        IF AP > 20 THEN RETURN END;
        WITH UserLog[AP] DO
            FOR C:=0 TO 9 DO
                ReadChar(SignOn, Name[C]);
            END;
            FOR C:=0 TO 5 DO
                ReadChar(SignOn, ch);
                IF (ch < 65C) OR (ch > 132C) THEN
                    Secret[C] := ch;
                ELSE;
                    Secret[C] := CHR((ORD(ch) - ORD('A') + 13) MOD 26 + ORD('A'));
                END;
            END;
        END;
        INC(AP);
    END;
END GetLog;

PROCEDURE MakeLog;
BEGIN;
    Reset(SignOn);
    AP := 0;
    LOOP
        IF AP > 20 THEN RETURN END;
        WITH UserLog[AP] DO
            FOR C := 0 TO 9 DO
                WriteChar(SignOn, Name[C]);
            END;
            FOR C := 0 TO 5 DO
                ch :=  Secret[C];
                IF ch <> 0C THEN
                    ch := CHR((ORD(ch) - ORD('A') + 13) MOD 26 + ORD('A'));
                END;
                WriteChar(SignOn, ch);
            END;
        END;
        INC(AP);
    END;
END MakeLog;

PROCEDURE GetUser;
BEGIN;
    WriteLn;
    WriteLn;
    WriteString("May I have your Name Please?");
    WriteLn;
    ReadString(UserId);
    FOR C := 0 TO 9 DO
        UserId[C] := CAP(UserId[C]);
    END;
    WriteLn;
    WriteLn;
    WriteString("Welcome, ");
    WriteString(UserId);
    WriteString(", To the world of PC Computing!");
    WriteLn;
END GetUser;

PROCEDURE TestWord;
BEGIN;
    IF CompareStr(PassWord, "CHANGE") = 0 THEN ChangeWord END;
    TP := 0;
    LOOP
        IF TP > 2 THEN
            ClrScreen;
            WriteString("You have entered an incorrect Password!");
            WriteLn;
            WriteString("You will not be allowed entry into this area!");
            FOR C:= 0 TO 9 DO
                UserId[C] := 0C;
                IF C < 6 THEN
                    PassWord[C] := 0C;
                END;
            END;
            EXIT;
        END;
        IF CompareStr(UserLog[AP].Secret, PassWord) = 0 THEN RETURN END;
        ClrScreen;
        WriteString("You have incorrectly entered your PassWord!");
        WriteLn;
        WriteString("You have used ");
        WriteInt(TP + 1, 1);
        WriteString(" chance out of 3 chances ");
        WriteLn;
        WriteString("to enter your correct password!");
        GetWord;
        INC(TP);
    END;
END TestWord;

PROCEDURE ChangeWord;
BEGIN;
    LOOP
        Assign(UserLog[AP].Secret, OldWord);
        FOR C := 0 TO 5 DO
            PassWord[C] := 0C;
        END;
        ClrScreen;
        WriteString("You will need to enter your old password");
        WriteLn;
        WriteString("In order to change it for another.");
        WriteLn;
        GetWord;
        IF CompareStr(OldWord, PassWord) = 0 THEN EXIT END;
    END;
    TP := 0;
    LOOP
        FOR C := 0 TO 5 DO
            PassWord[C] := 0C;
        END;
        ClrScreen;
        WriteString("You now need to enter your new Password,");
        WriteLn;
        GetWord;
        Assign(PassWord, SavePw);
        FOR C := 0 TO 5 DO
            PassWord[C] := 0C;
        END;
        WriteString("Please enter your new PassWord again.");
        WriteLn;
        WriteString("To be sure that we have it correctly entered!");
        WriteLn;
        GetWord;
        IF CompareStr(PassWord, SavePw) = 0 THEN
            Assign(PassWord, UserLog[AP].Secret);
            NewLog := TRUE;
            EXIT;
        END;
        INC(TP);
        IF TP > 2 THEN
            ClrScreen;
            WriteString("You have not correctly entered both copies,");
            WriteLn;
            WriteString("Would you like to try again?");
            WriteLn;
            WriteLn;
            WriteString("Or would you rather keep your old password,");
            WriteLn;
            WriteString("And try to change it another day?");
            WriteLn;
            WriteLn;
            WriteString("Please enter <S> to keep the same Password,");
            WriteLn;
            WriteString("Or enter <C> to Change your password.");
            LOOP
                Read(ch);
                IF (ch = 123C) OR (ch = 163C) THEN
                    Assign(OldWord, PassWord);
                    RETURN;
                END;
                IF (ch = 103C) OR (ch = 143C) THEN
                    TP := 0;
                    EXIT;
                END;
            END;
        END;
    END;
END ChangeWord;

PROCEDURE GetWord;
BEGIN;
    C := 0;
    WriteLn;
    WriteLn;
    WriteString("If you wish to change your Password, ");
    WriteLn;
    WriteString("Just type in the word 'Change'.");
    WriteLn;
    WriteLn;
    WriteString("May I have your Password Please?");
    WriteLn;
    LOOP
        Read(ch);
        IF (ch = 36C) OR (ch = 33C) THEN RETURN END;
        IF (ch = 10C) AND (C > 0) THEN
            DEC(C);
            Delete(PassWord,C,1);
        ELSE
            IF ch <> 10C THEN
                pc := CAP(ch);
                PassWord[C] := pc;
                INC(C);
            END;
        END;
        IF C > 5 THEN EXIT END;
    END;
    WriteString(7C);
END GetWord;

BEGIN;
    ClrScreen;
    GetUser;
    GetWord;
    GetLog;
    TestUser;
    IF (Found = FALSE) AND (NewLog = TRUE) THEN MakeUser END;
    TestWord;
    MakeLog;
    RedirectOutput("logtemp.bat");
    WriteString("Set ID=");
    WriteString(UserId);
    WriteLn;
    Close(SignOn);
    CloseOutput;
    ClrScreen;
END LogOn.
